package com.netease.hy;


import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import org.springframework.web.client.RestTemplate;
import sun.misc.BASE64Encoder;

import java.io.UnsupportedEncodingException;
import java.net.URLEncoder;
import java.security.MessageDigest;
import java.security.NoSuchAlgorithmException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;


public class mammutOpenApi {


    public static String HOST = "http://easydemo-workbench.163yun.com/";

    /*
    app_key  需要更换成自己的api_key
    */

    public static String API_KEY = "365dab73-48e9-435a-b85d-8454b83bd4c7";

    /*
    秘钥用来生成token 需要更换成自己的master_key
    */

    public static String MASTER_KEY = "3V4KmxDu4V28Z4n800V60CYx3TXVlchPyjKBVQKBi3izPim/oOGBiw==";


    protected  RestTemplate restApiTemplate;

    private  BASE64Encoder base64en;

    private MessageDigest md5;

    public mammutOpenApi() throws NoSuchAlgorithmException {
        restApiTemplate = new RestTemplate();
        base64en = new BASE64Encoder();
    }

    /* 获取token
     * */

    public  String getToken(String uri) throws UnsupportedEncodingException,NoSuchAlgorithmException {
        MessageDigest md5 = MessageDigest.getInstance("MD5");
        return base64en.encode(md5.digest((MASTER_KEY + uri).getBytes("utf-8")));
    }

    /*
    测试函数
     */

    public  void test(String uri) {

        try {
            List<String> list = new ArrayList<>();

            execSettings settings = new execSettings();
            settings.setConcurrentOption("skip");
            settings.setFailureAction("CANCEL_ALL");
            ArrayList<String> list1 = new ArrayList<>();
            settings.setDisabled(list1);
            slaDetail slaDetail = new slaDetail();

            String settings_json = JSON.toJSONString(settings);
            String slaDetail_json = JSON.toJSONString(slaDetail);

            String token = getToken(uri);
            Map<String, Object> param = new HashMap<>();
            param.put("product", "show");
            param.put("clusterId", "easyops-cluster");
            param.put("taskName", "eto_task");
            param.put("flowName", "eto_task");
            param.put("scheduleTime", "1636717829000");
            param.put("period", "1d");
            param.put("execSettings", settings_json);
//            param.put("jobDependences", "jobDependences:[]");
            param.put("jobDependences", list);
            param.put("slaDetail", slaDetail_json);
            param.put("isModify", false);
            param.put("apiKey", URLEncoder.encode(API_KEY,"utf-8"));
            param.put("token", URLEncoder.encode(token, "utf-8"));

            String url = HOST + uri;
            JSONObject result = restApiTemplate.postForObject(url, param, JSONObject.class);

            //System.out.println(result.toJSONString());


        } catch (UnsupportedEncodingException e) {

        } catch (NoSuchAlgorithmException e2) {

        }
    }

    public static void main(String[] args) throws NoSuchAlgorithmException, UnsupportedEncodingException {

        mammutOpenApi api = new mammutOpenApi();
        //api.test("/v1/openapi/etl/task/schedule");
        System.out.println(api.getToken("/v2/lineage/batch/table/task/writer"));
    }
}

